% BLOCK2FFT  Calculates the power in each frequency of a block of sound sample.
%
%  Power = BLOCK2FFT(WAV, SAMPLEFREQ, MINFREQ, MAXFREQ)
%
% Returns only the frequencies specified by minfreq and maxfreq,
% where samplefreq is the sample frequency of the wav.

function p = block2fft(wav, samplefreq, minfreq, maxfreq)

num_samples = length(wav);

f = fft(wav)/(num_samples/2);
seconds = num_samples / samplefreq;
l1 = floor(seconds * minfreq + 1);
l2 = floor(seconds * maxfreq + 1);

p = abs(f(l1:l2)).^2;

