function data2 = embed_clip(data, clip_length, back_clips, back_mixing_coef)


    rc = ceil(rand(1) * length(back_clips));
    i1 = ceil(rand(1) * (length(back_clips(rc).data)-clip_length));
    i2 = i1 + clip_length - 1;
    back_data = back_clips(rc).data(i1:i2);

    data_length = length(data);
        
    if (length(data) > clip_length) % choose section with highest power
        [max_power, index] = max(conv(ones(clip_length, 1), data.^2));       
        index = index - (clip_length-1)/2 - clip_length/2;
        i1 = min( max( floor(index), 1 ),  data_length-clip_length+1);
        i2 = i1 + clip_length - 1;
        data2 = back_data*back_mixing_coef + (1-back_mixing_coef)*data(i1:i2);
    else % blend background into data with data buffered by zeros
        left_buff = floor((clip_length-data_length)/2);
        right_buff = clip_length-data_length-left_buff;
        if (left_buff > 80 & right_buff > 80)
            ramp_size = 80;
        else 
            ramp_size = min(right_buff, left_buff);
        end
        if left_buff > 0
            left_buff_ramp(1:left_buff-ramp_size, 1) = [ones(left_buff-ramp_size, 1)];
            left_buff_ramp(left_buff-ramp_size+1:left_buff, 1) = (1:-(1-back_mixing_coef)/ramp_size:back_mixing_coef+(1-back_mixing_coef)/ramp_size);
        else
            left_buff_ramp = zeros(0, 1);
        end
        if right_buff > 0
            right_buff_ramp(1:right_buff-ramp_size, 1) = [ones(right_buff-ramp_size, 1)];
            right_buff_ramp(right_buff-ramp_size+1:right_buff, 1) = (1:-(1-back_mixing_coef)/ramp_size:back_mixing_coef+(1-back_mixing_coef)/ramp_size);
        else
            right_buff_ramp = zeros(0, 1);
        end
        
        data2 = [left_buff_ramp.*back_data(1:left_buff) ; ...
                 back_data(left_buff+1:left_buff+data_length)*back_mixing_coef ; ...
                 right_buff_ramp.*back_data(left_buff+data_length+1:end)] + ...
            (1-back_mixing_coef)*[zeros(left_buff, 1) ; data ; zeros(right_buff, 1)];
    end
         