function final_classifier_test(object_nums, num_stages)


object_name(1).name = 'car_horn';
object_name(2).name = 'close_door';
object_name(3).name = 'dog_bark';
object_name(4).name = 'door_bell';
object_name(5).name = 'explosion';
object_name(6).name = 'female_laugh';
object_name(7).name = 'gunshot';
object_name(8).name = 'laser_gun';
object_name(9).name = 'light_saber';
object_name(10).name = 'male_laugh';
object_name(11).name = 'meow';
object_name(12).name = 'phone';
object_name(13).name = 'scream';
object_name(14).name = 'swords';

for zz = 1:length(object_nums)
object_id = object_nums(zz);    

% loading classifiers
for s = 1:num_stages 
    load(['./data/online_training/' object_name(object_id).name '/global_classifier', num2str(s), '.mat']);
    if s == num_stages
        global_classifier.threshold = 0;
    end
    classifiers(s) = global_classifier;
end

% read all tracks and merge into one long data vector
data_dir = './data';

disp('preparing data')
tracks = read_wav_files(data_dir, ...
                        ['./data/online_training/' object_name(object_id).name '/negative_test_list.txt']);

data_length = 0;
for t = 1:length(tracks)
    data_length = data_length + length(tracks(t).data);
end
disp(num2str(data_length/8000))
data = zeros(data_length, 1);
data_length = 0;
for t = 1:length(tracks)
    data(data_length+1:data_length+length(tracks(t).data)) = tracks(t).data;
    data_length = data_length + length(tracks(t).data);
    %if t > 2
    %    tracks(t).data=0;  % reduce memory usage
    %end
end   
% for memory reasons, make data no longer than 45 minutes
if length(data) > 8000*60*45
    data = data(1:8000*60*45);
    data_length = length(data);
end

% create positive examples
pos_clip_list = ['./data/online_training/' object_name(object_id).name '/positive_list.txt'];
pos_clips = read_wav_files(data_dir, pos_clip_list);
pos_clips = pos_clips(round(length(pos_clips)/2)+1:end);

num_synth = 15;
num_neg = 0;
med_length = classifiers(1).data_length;
[pos_data, pos_labels] = create_uniform_length_clips(pos_clips, tracks, num_synth, num_neg, med_length);

clear tracks
clear pos_clips;
    
% preparing for output
output_dir = ['./tmp/results/' object_name(object_id).name];
if exist(output_dir) == 0
    mkdir('./tmp/results/', object_name(object_id).name);
end
delete(['./tmp/results/' object_name(object_id).name '/*.wav']);    

disp(['testing ' object_name(object_id).name]);

% set a "safe" threshold
classifiers(num_stages).threshold = -20.0;
figure(1), hold off

for stage = 1:num_stages
% testing negative examples
    disp(['stage: ' num2str(stage)]);
    disp('testing negative')
    [passed_times, passed_data, confidences, removed_confidences, num_windows] = ...
        test_track(data, classifiers(1:stage), output_dir);

    neg_confidences = removed_confidences;
    num_hours = data_length/8000/60/60;
    if stage == 1
        disp(['num hours = ' num2str(num_hours) ' num_windows = ' num2str(num_windows)]);
    end
    

    disp('testing positive')
    pos_confidences = zeros(length(pos_labels), 1);
    for s =1:length(pos_labels)
        [pos_confidences(s), passed] = test_single_clip(pos_data(:, s), classifiers(1:stage));
        if ~ passed
            pos_confidences(s) = -1E10;
        end
    end

    confidences = [pos_confidences ; neg_confidences];
    labels = [ones(length(pos_confidences), 1) ; -ones(length(neg_confidences), 1)];    

    [roc, true_pos, false_pos] = compute_roc(confidences, labels);
    
    colors = 'rgb';   
    figure(1), plot(false_pos*length(neg_confidences)/num_hours, true_pos, colors(stage));
    hold on
    
    fid = fopen(['./results/' object_name(object_id).name '/test.' object_name(object_id).name '.' num2str(stage) '.txt'], 'w');
    fprintf(fid, 'num_hours: %f  num_pos: %d  num_windows:  %d\n', num_hours, length(pos_labels), num_windows);
    for s = 1:length(true_pos)
        fprintf(fid, '%f    %f    %f\n', false_pos(s)*length(neg_confidences)/num_hours, true_pos(s), ...
                                         roc(s).threshold);
    end
    fclose(fid);
end
    
end       

