function threshold = get_best_threshold(confidences, labels, pos_cost, neg_cost, max_pos_error)
    
    X = sortrows([confidences labels]);
    confidences = X(:, 1);
    labels = X(:, 2);    

    num_pos = sum(labels == 1);
    num_neg = sum(labels == -1);    
    
    threshold_set = 0;
    
    pos_missed = 0;
    neg_missed = 0;
    min_cost = 1000;
    %disp([confidences(1:50) labels(1:50)]);
    %[g, gn] = grp2idx(confidences);
    %gn
    
    while ~threshold_set
    
        for s = 1:length(confidences)-1
            pos_missed = pos_missed + (labels(s)==1);
            neg_missed = neg_missed + (labels(s)==-1);
            if confidences(s) < confidences(s+1)
                cost = pos_missed*pos_cost + (num_neg-neg_missed)*neg_cost;
                if (cost < min_cost | ~threshold_set) & (pos_missed/num_pos <= max_pos_error)
                    threshold = (confidences(s) + confidences(s+1))/2;
                    min_cost = cost;
                    threshold_set = 1;
                end
            end
        end

        max_pos_error = max_pos_error*2
    end